' Developer's Image Library - Converted "ILUT.h" Import Include file
' By: Todd Riggins(www.exodev.com)
' Jan. 16,2005 Update: Win32 functions converted

$USE "ILUT.lib"

CONST ILUT_VERSION_1_6_1					=1
CONST ILUT_VERSION							=161

' Attribute Bits
CONST ILUT_OPENGL_BIT						=0x00000001
CONST ILUT_D3D_BIT							=0x00000002
CONST ILUT_ALL_ATTRIB_BITS					=0x000FFFFF

' Error Types
CONST ILUT_INVALID_ENUM						=0x0501
CONST ILUT_OUT_OF_MEMORY					=0x0502
CONST ILUT_INVALID_VALUE					=0x0505
CONST ILUT_ILLEGAL_OPERATION				=0x0506
CONST ILUT_INVALID_PARAM					=0x0509
CONST ILUT_COULD_NOT_OPEN_FILE				=0x050A
CONST ILUT_STACK_OVERFLOW					=0x050E
CONST ILUT_STACK_UNDERFLOW					=0x050F
CONST ILUT_BAD_DIMENSIONS					=0x0511
CONST ILUT_NOT_SUPPORTED					=0x0550

' State Definitions
CONST ILUT_PALETTE_MODE						=0x0600
CONST ILUT_OPENGL_CONV						=0x0610
CONST ILUT_D3D_MIPLEVELS					=0x0620
CONST ILUT_MAXTEX_WIDTH						=0x0630
CONST ILUT_MAXTEX_HEIGHT					=0x0631
CONST ILUT_MAXTEX_DEPTH						=0x0632
CONST ILUT_GL_USE_S3TC						=0x0634
CONST ILUT_D3D_USE_DXTC						=0x0634
CONST ILUT_GL_GEN_S3TC						=0x0635
CONST ILUT_D3D_GEN_DXTC						=0x0635
CONST ILUT_S3TC_FORMAT						=0x0705
CONST ILUT_DXTC_FORMAT						=0x0705
CONST ILUT_D3D_POOL							=0x0706

' Values
CONST ILUT_VERSION_NUM						=0x0DE2

' ImageLib Utility Toolkit Functions
DECLARE IMPORT,ilutDisable(Mode:UINT),INT
DECLARE IMPORT,ilutEnable(Mode:UINT),INT
DECLARE IMPORT,ilutGetBoolean(Mode:UINT),INT
DECLARE IMPORT,ilutGetBooleanv(Mode:UINT, BooleanParam:POINTER)
DECLARE IMPORT,ilutGetInteger(Mode:UINT),INT
DECLARE IMPORT,ilutGetIntegerv(Mode:UINT, IntParam:POINTER)
DECLARE IMPORT,ilutGetString(StringName:UINT),POINTER :' Pointer to a char* ie:string
DECLARE IMPORT,ilutInit()
DECLARE IMPORT,ilutIsDisabled(Mode:UINT),INT
DECLARE IMPORT,ilutIsEnabled(Mode:UINT),INT
DECLARE IMPORT,ilutPopAttrib()
DECLARE IMPORT,ilutPushAttrib(Bits:UINT)
DECLARE IMPORT,ilutSetInteger(Mode:UINT,Param:INT)

' The different rendering api's...
CONST ILUT_OPENGL		=0
CONST ILUT_ALLEGRO		=1
CONST ILUT_WIN32		=2
CONST ILUT_DIRECT3D8	=3

DECLARE IMPORT,ilutRenderer(Renderer:UINT),INT

'// ImageLib Utility Toolkit's OpenGL Functions
DECLARE IMPORT,ilutGLBindTexImage(),UINT
DECLARE IMPORT,ilutGLBindMipmaps(),UINT
DECLARE IMPORT,ilutGLBuildMipmaps(),INT
DECLARE IMPORT,ilutGLLoadImage(FileName:POINTER),UINT
DECLARE IMPORT,ilutGLScreen(),INT
DECLARE IMPORT,ilutGLScreenie(),INT
DECLARE IMPORT,ilutGLSaveImage(FileName:POINTER,TexID:UINT),INT
DECLARE IMPORT,ilutGLSetTex(TexID:UINT),INT
DECLARE IMPORT,ilutGLTexImage(Level:UINT),INT

'// ImageLib Utility Toolkit's Allegro Functions
' <Todd: inlcude an Allegro Include File here...?>
DECLARE IMPORT,ilutAllegLoadImage(const_ILstring_FileName:POINTER),POINTER :'returns a pointer to a BITMAP
DECLARE IMPORT,ilutConvertToAlleg(Pal:UINT),POINTER :'returns a pointer to a BITMAP

'// ImageLib Utility Toolkit's SDL Functions
' <Todd: definetly inlcude a SDL Include File here...>
DECLARE IMPORT,ilutConvertToSDLSurface(flags:uint),POINTER :'returns a pointer to a SDL_Surface
DECLARE IMPORT,ilutSDLSurfaceLoadImage(const_ILstring_FileName:POINTER),POINTER :'returns a pointer to a SDL_Surface
DECLARE IMPORT,ilutSDLSurfaceFromBitmap(SDL_Surface_Bitmap:POINTER),CHAR :'returns a boolean

'// ImageLib Utility Toolkit's BeOS Functions
' <Todd: Let me know when IBasic Pro works on a BEOS system. ;)>
'	 BBitmap  ilutConvertToBBitmap(ILvoid);

'// ImageLib Utility Toolkit's Win32 GDI Functions
DECLARE IMPORT,ilutConvertToHBitmap(hDC:UINT),UINT
DECLARE IMPORT,ilutFreePaddedData(ILubyte_Data:POINTER)
DECLARE IMPORT,ilutGetBmpInfo(BITMAPINFO_Info:POINTER)
DECLARE IMPORT,ilutGetHPal(),UINT
DECLARE IMPORT,ilutGetPaddedData(),POINTER :' Returns ILubyte(ie: CHAR) Pointer
DECLARE IMPORT,ilutGetWinClipboard(),CHAR
DECLARE IMPORT,ilutLoadResource(hInst:UINT, ID:INT, const_ILstring_ResourceType:POINTER, enumType:UINT),CHAR
DECLARE IMPORT,ilutSetHBitmap(Bitmap:UINT),CHAR
DECLARE IMPORT,ilutSetHPal(Pal:UINT),CHAR
DECLARE IMPORT,ilutSetWinClipboard(),CHAR
DECLARE IMPORT,ilutWinLoadImage(const_ILstring_FileName:POINTER, hDC:UINT),UINT
DECLARE IMPORT,ilutWinLoadUrl(const_ILstring_Url:POINTER),CHAR
DECLARE IMPORT,ilutWinPrint(XPos:UINT, YPos:UINT, Width:UINT, Height:UINT, hDC:UINT),CHAR
DECLARE IMPORT,ilutWinSaveImage(const_ILstring_FileName:POINTER, Bitmap:UINT),CHAR

'// ImageLib Utility Toolkit's DirectX 8 Functions
' <Todd: Let me know when DirectX 8 Functioanlity of IL is needed( ie: with proof of need ) ;)>
'		#include <d3d8.h>
'		 ILvoid	 ilutD3D8MipFunc(ILuint NumLevels);
'		 IDirect3DTexture8*  ilutD3D8Texture(IDirect3DDevice8 *Device);
'		 IDirect3DVolumeTexture8*  ilutD3D8VolumeTexture(IDirect3DDevice8 *Device);
'		 ILboolean	 ilutD3D8TexFromFile(IDirect3DDevice8 *Device, char *FileName, IDirect3DTexture8 **Texture);
'		 ILboolean	 ilutD3D8VolTexFromFile(IDirect3DDevice8 *Device, char *FileName, IDirect3DVolumeTexture8 **Texture);
'		 ILboolean	 ilutD3D8TexFromFileInMemory(IDirect3DDevice8 *Device, ILvoid *Lump, ILuint Size, IDirect3DTexture8 **Texture);
'		 ILboolean	 ilutD3D8VolTexFromFileInMemory(IDirect3DDevice8 *Device, ILvoid *Lump, ILuint Size, IDirect3DVolumeTexture8 **Texture);
'		 ILboolean	 ilutD3D8TexFromFileHandle(IDirect3DDevice8 *Device, ILHANDLE File, IDirect3DTexture8 **Texture);
'		 ILboolean	 ilutD3D8VolTexFromFileHandle(IDirect3DDevice8 *Device, ILHANDLE File, IDirect3DVolumeTexture8 **Texture);
'		// These two are not tested yet.
'		 ILboolean  ilutD3D8TexFromResource(IDirect3DDevice8 *Device, HMODULE SrcModule, char *SrcResource, IDirect3DTexture8 **Texture);
'		 ILboolean  ilutD3D8VolTexFromResource(IDirect3DDevice8 *Device, HMODULE SrcModule, char *SrcResource, IDirect3DVolumeTexture8 **Texture);

'		 ILboolean  ilutD3D8LoadSurface(IDirect3DDevice8 *Device, IDirect3DSurface8 *Surface);
